package com.iflytek.turing.jni;

import org.bytedeco.javacpp.FunctionPointer;
import org.bytedeco.javacpp.annotation.ByPtrPtr;
import org.bytedeco.javacpp.PointerPointer;
import org.bytedeco.javacpp.annotation.Const;
import java.nio.IntBuffer;
import org.bytedeco.javacpp.IntPointer;
import java.nio.ByteBuffer;
import org.bytedeco.javacpp.annotation.ByRef;
import org.bytedeco.javacpp.annotation.ByVal;
import org.bytedeco.javacpp.annotation.NoOffset;
import org.bytedeco.javacpp.annotation.MemberGetter;
import org.bytedeco.javacpp.annotation.Namespace;
import org.bytedeco.javacpp.Pointer;
import org.bytedeco.javacpp.annotation.Cast;
import org.bytedeco.javacpp.BytePointer;
import org.bytedeco.javacpp.Loader;

public class TALKER extends com.iflytek.turing.jni.presets.TALKER
{
    public static final int None = 0;
    public static final int Continue = 1;
    public static final int Finish = 2;
    public static final int Close = 3;
    public static final int NoStatus = 0;
    public static final int End = 1;
    public static final int OutputOverLimit = 2;
    public static final int InputOverLimit = 3;
    
    static {
        Loader.load();
    }
    
    public static native tInterface TalkerInitialize(@Cast({ "const char*" }) final BytePointer p0);
    
    public static native tInterface TalkerInitialize();
    
    public static native tInterface TalkerInitialize(final String p0);
    
    @Namespace("talker")
    public static class ChatResult extends Pointer
    {
        static {
            Loader.load();
        }
        
        public ChatResult() {
            super((Pointer)null);
            this.allocate();
        }
        
        public ChatResult(final long size) {
            super((Pointer)null);
            this.allocateArray(size);
        }
        
        public ChatResult(final Pointer p) {
            super(p);
        }
        
        private native void allocate();
        
        private native void allocateArray(final long p0);
        
        public ChatResult position(final long position) {
            return (ChatResult)super.position(position);
        }
        
        public ChatResult getPointer(final long i) {
            return (ChatResult)new ChatResult(this).offsetAddress(i);
        }
        
        public native int rlt_id();
        
        public native ChatResult rlt_id(final int p0);
        
        public native int prompt_tokens();
        
        public native ChatResult prompt_tokens(final int p0);
        
        public native int result_tokens();
        
        public native ChatResult result_tokens(final int p0);
        
        public native int prefix_result_tokens();
        
        public native ChatResult prefix_result_tokens(final int p0);
        
        @Cast({ "talker::ResultStatus" })
        public native int status();
        
        public native ChatResult status(final int p0);
        
        @Cast({ "talker::OutputStatus" })
        public native int output_status();
        
        public native ChatResult output_status(final int p0);
        
        public native void clear();
    }
    
    @Namespace("talker")
    public static class LogLevel extends Pointer
    {
        public static final int TRACE;
        public static final int DEBUG;
        public static final int INFO;
        public static final int WARN;
        public static final int ERROR;
        public static final int CRITICAL;
        public static final int OFF;
        
        static {
            Loader.load();
            TRACE = TRACE();
            DEBUG = DEBUG();
            INFO = INFO();
            WARN = WARN();
            ERROR = ERROR();
            CRITICAL = CRITICAL();
            OFF = OFF();
        }
        
        public LogLevel() {
            super((Pointer)null);
            this.allocate();
        }
        
        public LogLevel(final long size) {
            super((Pointer)null);
            this.allocateArray(size);
        }
        
        public LogLevel(final Pointer p) {
            super(p);
        }
        
        private native void allocate();
        
        private native void allocateArray(final long p0);
        
        public LogLevel position(final long position) {
            return (LogLevel)super.position(position);
        }
        
        public LogLevel getPointer(final long i) {
            return (LogLevel)new LogLevel(this).offsetAddress(i);
        }
        
        @MemberGetter
        public static native int TRACE();
        
        @MemberGetter
        public static native int DEBUG();
        
        @MemberGetter
        public static native int INFO();
        
        @MemberGetter
        public static native int WARN();
        
        @MemberGetter
        public static native int ERROR();
        
        @MemberGetter
        public static native int CRITICAL();
        
        @MemberGetter
        public static native int OFF();
    }
    
    @Namespace("talker")
    @NoOffset
    public static class TalkerStatus extends Pointer
    {
        public static final int OK;
        public static final int FileError;
        public static final int ResourceError;
        public static final int HandleIsNull;
        public static final int JsonParseError;
        public static final int NotStartError;
        public static final int BufferSmallError;
        public static final int NotImplementedError;
        public static final int ParameterIsNull;
        public static final int ChatNotHappen;
        public static final int ParameterError;
        public static final int AuthorizationError;
        public static final int ImageFileError;
        public static final int ImageFormatError;
        public static final int UserActivateError;
        public static final int Failure;
        
        static {
            Loader.load();
            OK = OK();
            FileError = FileError();
            ResourceError = ResourceError();
            HandleIsNull = HandleIsNull();
            JsonParseError = JsonParseError();
            NotStartError = NotStartError();
            BufferSmallError = BufferSmallError();
            NotImplementedError = NotImplementedError();
            ParameterIsNull = ParameterIsNull();
            ChatNotHappen = ChatNotHappen();
            ParameterError = ParameterError();
            AuthorizationError = AuthorizationError();
            ImageFileError = ImageFileError();
            ImageFormatError = ImageFormatError();
            UserActivateError = UserActivateError();
            Failure = Failure();
        }
        
        public TalkerStatus(final Pointer p) {
            super(p);
        }
        
        @MemberGetter
        public static native int OK();
        
        @MemberGetter
        public static native int FileError();
        
        @MemberGetter
        public static native int ResourceError();
        
        @MemberGetter
        public static native int HandleIsNull();
        
        @MemberGetter
        public static native int JsonParseError();
        
        @MemberGetter
        public static native int NotStartError();
        
        @MemberGetter
        public static native int BufferSmallError();
        
        @MemberGetter
        public static native int NotImplementedError();
        
        @MemberGetter
        public static native int ParameterIsNull();
        
        @MemberGetter
        public static native int ChatNotHappen();
        
        @MemberGetter
        public static native int ParameterError();
        
        @MemberGetter
        public static native int AuthorizationError();
        
        @MemberGetter
        public static native int ImageFileError();
        
        @MemberGetter
        public static native int ImageFormatError();
        
        @MemberGetter
        public static native int UserActivateError();
        
        @MemberGetter
        public static native int Failure();
        
        public TalkerStatus() {
            super((Pointer)null);
            this.allocate();
        }
        
        private native void allocate();
        
        public TalkerStatus(final int c) {
            super((Pointer)null);
            this.allocate(c);
        }
        
        private native void allocate(final int p0);
        
        @Cast({ "bool" })
        public native boolean IsOk();
        
        public native int Code();
    }
    
    @Namespace("talker")
    public static class tChatInst extends Pointer
    {
        static {
            Loader.load();
        }
        
        public tChatInst(final Pointer p) {
            super(p);
        }
        
        @ByVal
        public native TalkerStatus start(@Cast({ "const char*" }) final BytePointer p0);
        
        @ByVal
        public native TalkerStatus start(final String p0);
        
        @ByVal
        public native TalkerStatus stop();
        
        @ByVal
        public native TalkerStatus talk(@Cast({ "const char*" }) final BytePointer p0, @Cast({ "const char*" }) final BytePointer p1);
        
        @ByVal
        public native TalkerStatus talk(@Cast({ "const char*" }) final BytePointer p0);
        
        @ByVal
        public native TalkerStatus talk(final String p0, final String p1);
        
        @ByVal
        public native TalkerStatus talk(final String p0);
        
        @ByVal
        public native TalkerStatus get_telegram_result(@Cast({ "char*" }) final BytePointer p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2, final int p3);
        
        @ByVal
        public native TalkerStatus get_telegram_result(@Cast({ "char*" }) final BytePointer p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2);
        
        @ByVal
        public native TalkerStatus get_telegram_result(@Cast({ "char*" }) final ByteBuffer p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2, final int p3);
        
        @ByVal
        public native TalkerStatus get_telegram_result(@Cast({ "char*" }) final ByteBuffer p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2);
        
        @ByVal
        public native TalkerStatus get_telegram_result(@Cast({ "char*" }) final byte[] p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2, final int p3);
        
        @ByVal
        public native TalkerStatus get_telegram_result(@Cast({ "char*" }) final byte[] p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2);
        
        @ByVal
        public native TalkerStatus get_telegram_json_result(@Cast({ "char*" }) final BytePointer p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2, final int p3);
        
        @ByVal
        public native TalkerStatus get_telegram_json_result(@Cast({ "char*" }) final BytePointer p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2);
        
        @ByVal
        public native TalkerStatus get_telegram_json_result(@Cast({ "char*" }) final ByteBuffer p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2, final int p3);
        
        @ByVal
        public native TalkerStatus get_telegram_json_result(@Cast({ "char*" }) final ByteBuffer p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2);
        
        @ByVal
        public native TalkerStatus get_telegram_json_result(@Cast({ "char*" }) final byte[] p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2, final int p3);
        
        @ByVal
        public native TalkerStatus get_telegram_json_result(@Cast({ "char*" }) final byte[] p0, @Cast({ "int64_t" }) final long p1, @ByRef final ChatResult p2);
        
        @ByVal
        public native TalkerStatus get_result(@Cast({ "char*" }) final BytePointer p0, @Cast({ "int64_t" }) final long p1, final int p2);
        
        @ByVal
        public native TalkerStatus get_result(@Cast({ "char*" }) final BytePointer p0, @Cast({ "int64_t" }) final long p1);
        
        @ByVal
        public native TalkerStatus get_result(@Cast({ "char*" }) final ByteBuffer p0, @Cast({ "int64_t" }) final long p1, final int p2);
        
        @ByVal
        public native TalkerStatus get_result(@Cast({ "char*" }) final ByteBuffer p0, @Cast({ "int64_t" }) final long p1);
        
        @ByVal
        public native TalkerStatus get_result(@Cast({ "char*" }) final byte[] p0, @Cast({ "int64_t" }) final long p1, final int p2);
        
        @ByVal
        public native TalkerStatus get_result(@Cast({ "char*" }) final byte[] p0, @Cast({ "int64_t" }) final long p1);
        
        @ByVal
        public native TalkerStatus get_nbest_result(@Cast({ "char*" }) final BytePointer p0, @Cast({ "int64_t" }) final long p1, final int p2);
        
        @ByVal
        public native TalkerStatus get_nbest_result(@Cast({ "char*" }) final BytePointer p0, @Cast({ "int64_t" }) final long p1);
        
        @ByVal
        public native TalkerStatus get_nbest_result(@Cast({ "char*" }) final ByteBuffer p0, @Cast({ "int64_t" }) final long p1, final int p2);
        
        @ByVal
        public native TalkerStatus get_nbest_result(@Cast({ "char*" }) final ByteBuffer p0, @Cast({ "int64_t" }) final long p1);
        
        @ByVal
        public native TalkerStatus get_nbest_result(@Cast({ "char*" }) final byte[] p0, @Cast({ "int64_t" }) final long p1, final int p2);
        
        @ByVal
        public native TalkerStatus get_nbest_result(@Cast({ "char*" }) final byte[] p0, @Cast({ "int64_t" }) final long p1);
        
        public native void destory();
        
        public native void reset_parameter();
        
        public native void set_telegram_chunk(final int p0);
        
        public native int get_telegram_chunk();
        
        public native void set_search_limit(final int p0);
        
        public native int get_search_limit();
        
        public native void set_sequence_limit(final int p0);
        
        public native int get_sequence_limit();
        
        public native void set_temperature(final float p0);
        
        public native float get_temperature();
        
        public native void set_topk(final int p0);
        
        public native int get_topk();
        
        public native void set_seed(final int p0);
        
        public native int get_seed();
        
        public native void set_punish_value(final float p0);
        
        public native float get_punish_value();
        
        public native void set_punish_scale(final float p0);
        
        public native float get_punish_scale();
        
        public native void set_topp(final float p0);
        
        public native float get_topp();
        
        @ByVal
        public native TalkerStatus add_patch_res(@Cast({ "const char*" }) final BytePointer p0);
        
        @ByVal
        public native TalkerStatus add_patch_res(final String p0);
        
        public native float get_max_response_time();
        
        public native void set_max_response_time(final float p0);
        
        public native void set_end_id(final IntPointer p0, final int p1);
        
        public native void set_end_id(final IntBuffer p0, final int p1);
        
        public native void set_end_id(final int[] p0, final int p1);
        
        public native void set_end_str(@Cast({ "const char*" }) final BytePointer p0);
        
        public native void set_end_str(final String p0);
    }
    
    @Namespace("talker")
    public static class tInterface extends Pointer
    {
        static {
            Loader.load();
        }
        
        public tInterface(final Pointer p) {
            super(p);
        }
        
        public native tChatInst create_inst();
        
        @ByVal
        public native TalkerStatus load_tokenizer(@Cast({ "const char*" }) final BytePointer p0);
        
        @ByVal
        public native TalkerStatus load_tokenizer(final String p0);
        
        @ByVal
        public native TalkerStatus load_tokenizer_from_memory(@Const final Pointer p0, @Cast({ "int64_t" }) final long p1);
        
        @ByVal
        public native TalkerStatus load_from_memory(@Const final Pointer p0, @Cast({ "int64_t" }) final long p1);
        
        @ByVal
        public native TalkerStatus load_from_file(@Cast({ "const char*" }) final BytePointer p0);
        
        @ByVal
        public native TalkerStatus load_from_file(final String p0);
        
        @ByVal
        public native TalkerStatus load_speculative_model(@Cast({ "const char*" }) final BytePointer p0, final int p1);
        
        @ByVal
        public native TalkerStatus load_speculative_model(final String p0, final int p1);
        
        @Cast({ "bool" })
        public native boolean dongle_check_success();
        
        public native int get_token_num(@Cast({ "const char*" }) final BytePointer p0);
        
        public native int get_token_num(final String p0);
        
        @ByVal
        public native TalkerStatus ModelUpdate(@Cast({ "const char**" }) final PointerPointer p0, final int p1);
        
        @ByVal
        public native TalkerStatus ModelUpdate(@Cast({ "const char**" }) @ByPtrPtr final BytePointer p0, final int p1);
        
        @ByVal
        public native TalkerStatus ModelUpdate(@Cast({ "const char**" }) @ByPtrPtr final ByteBuffer p0, final int p1);
        
        @ByVal
        public native TalkerStatus ModelUpdate(@Cast({ "const char**" }) @ByPtrPtr final byte[] p0, final int p1);
        
        public native void destory();
    }
    
    public static class Proc_TalkerInitialize extends FunctionPointer
    {
        static {
            Loader.load();
        }
        
        public Proc_TalkerInitialize(final Pointer p) {
            super(p);
        }
        
        protected Proc_TalkerInitialize() {
            this.allocate();
        }
        
        private native void allocate();
        
        public native tInterface call(@Cast({ "const char*" }) final BytePointer p0);
    }
}
